<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Owner Computes Rule</TITLE>
<link href="lic_13.html" rel=Next>
<link href="lic_11.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_11.html">previous</A>, <A HREF="lic_13.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC12" HREF="lic_toc.html#TOC12">Owner Computes Rule</A></H3>


<PRE>
 A(N,N), B(N,N)
 DISTRIBUTE (*,BLOCK) A, B
 do i = 2, N-1
   do j = i, N-1
     A(i, j) = A(i-1, j-1)
   enddo
 enddo
</PRE>

<P>
<A NAME="IDX138"></A>

</P>
<P>
For the above loop nest, the computation distribution is found using the
owner computes rule.  The array <SAMP>`A'</SAMP> is distributed, thus the write
access will determine the distribution of the loop nest.  Since the
block size used to distribute the array depends on number of processors,
which is not known at compile time, a symbolic constant block size is
used (<SAMP>`blk'</SAMP>).  Since symbolic block size makes the system of
inequalities non-linear, an extension to linear programming is used to
solve this system (See the SUIFMATH Library Reference Manual).
<A NAME="IDX139"></A>
<A NAME="IDX140"></A>
<A NAME="IDX141"></A>
<A NAME="IDX142"></A>
<A NAME="IDX143"></A>
<A NAME="IDX144"></A>
<A NAME="IDX145"></A>
<A NAME="IDX146"></A>

</P>


<PRE>
iter = [2 &#60;= i &#60;= N - 1
        i &#60;= j &#60;= N - 1 ]

dist = [blk*p &#60;= by &#60; blk*p + blk ]

lhs = [bx = i
       by = j ]

res = { iter, dist, lhs }

#final = res.order(N p i j bx by)
final.code(2)

end
</PRE>

<P>
<A NAME="IDX147"></A>

</P>
<P>
The printout of the example session:

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example3
iter = [2 &#60;= i &#60;= N - 1
        i &#60;= j &#60;= N - 1]
-1+N-j &#62;= 0
j-i &#62;= 0
-1+N-i &#62;= 0
-2+i &#62;= 0

dist = [blk*p &#60;= by &#60; blk*p + blk ]
-1+blk+blk*p-by &#62;= 0
-blk*p+by &#62;= 0

lhs = [bx = i
       by = j ]
by-j &#62;= 0
-by+j &#62;= 0
bx-i &#62;= 0
-bx+i &#62;= 0

res = { iter, dist, lhs }
-1+N-j &#62;= 0
j-i &#62;= 0
-1+N-i &#62;= 0
-2+i &#62;= 0
-1+blk+blk*p-by &#62;= 0
-blk*p+by &#62;= 0
-j+by &#62;= 0
j-by &#62;= 0
-i+bx &#62;= 0
i-bx &#62;= 0

#final = res.order(N p i j bx by)
final.code(2)

for(p = 2/blk; p &#60;= (-1+N)/blk; p++)
   for(i = 2; i &#60;= min(-1+N, -1+blk+blk*p); i++)
      for(j = max(blk*p, i); j &#60;= min(-1+N, -1+blk+blk*p); j++) {
         bx = i;
         by = j;
      }
end
 &#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX148"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_11.html">previous</A>, <A HREF="lic_13.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
